package mispClient;

import java.net.Socket;
import java.net.ConnectException;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;


public class MispClient
{
	private	static	final	int	BUFFER_SIZE = 8192;

	private	String	host;
	private	int	port;

	public	MispClient( String  host ,  int  port )
	{
		this.host = host;
		this.port = port;
	}

	public	InputStream	getResultStream( InputStream  in )
					throws ConnectException , IOException
	{
		Socket	socket = new Socket( this.host , port );

		OutputStream	out = socket.getOutputStream();

		byte[]	buf = new byte[BUFFER_SIZE];
		int	nRead = 0;

		while( (nRead = in.read( buf )) > 0 )
		{
			out.write( buf , 0 , nRead );
		}

		in.close();

		socket.shutdownOutput();

		return( socket.getInputStream() );
	}


	public	void	issue( MispCommand  command )
					throws MispCommandException ,
					       ConnectException , IOException

	{
		InputStream	input = command.getInputStream();

		if ( input == null )
		{
			return;
		}

		InputStream	response = this.getResultStream( input );

		command.processResponse( response );
	}
}
